// Generated by CoffeeScript 1.9.3
var Container, clearCache, evaluateType, getFullPath, getPath, isRelative;

Container = require('./container');

isRelative = function(path) {
  return path.indexOf('.') === 0;
};

getFullPath = function(path, basePath) {
  if (typeof window !== "undefined" && window !== null) {
    return path;
  } else if (isRelative(path)) {
    return [basePath, path].join('/');
  } else {
    return [basePath, 'node_modules', path].join('/');
  }
};

evaluateType = function(moduleConfig, module) {
  var path;
  if (moduleConfig.type != null) {
    return moduleConfig.type;
  }
  path = moduleConfig.require || moduleConfig;
  if (typeof module === 'function' && isRelative(path)) {
    return 'factory';
  } else {
    return 'value';
  }
};

getPath = function(moduleConfig) {
  if (typeof moduleConfig === 'string') {
    return moduleConfig;
  } else {
    return moduleConfig.require;
  }
};

clearCache = function(modules, basePath) {
  return Object.keys(modules).forEach(function(key) {
    var fullPath, moduleConfig, path;
    moduleConfig = modules[key];
    path = getPath(moduleConfig);
    fullPath = getFullPath(path, basePath);
    return delete require.cache[require.resolve(fullPath)];
  });
};

module.exports = function(options) {
  var basePath, config, di, modules, opts, parents;
  config = options.config, basePath = options.basePath, opts = options.opts, parents = options.parents;
  if (config == null) {
    throw new TypeError('No configuration was provided for loadConfig');
  }
  di = new Container(opts, parents);
  modules = config.modules || {};
  if ((options != null ? options.clearCache : void 0) === true) {
    clearCache(modules, basePath);
  }
  Object.keys(modules).forEach(function(key) {
    var e, fullPath, module, moduleConfig, path, type;
    moduleConfig = modules[key];
    path = getPath(moduleConfig);
    fullPath = getFullPath(path, basePath);
    try {
      module = require(fullPath);
    } catch (_error) {
      e = _error;
      module = require(path);
    }
    type = evaluateType(moduleConfig, module);
    if (type === 'factory') {
      return di.factory(key, module);
    } else {
      return di.value(key, module);
    }
  });
  return di;
};
